/* soundmosaic, Copyright (c) 2001-2007 Steven Hazel <sah@thalassocracy.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */
#ifndef __HTTP_H__
#define __HTTP_H__

#include <limits.h>
#include "io_buffer.h"

#define HTTP_END_HEADERS 0x0D0A0D0A // CRLFCRLF
#define HTTP_END_HEADER  0x0D0A

#define HTTP_UNKNOWN -1
#define HTTP_GET 1
#define HTTP_HEAD 2
#define HTTP_POST 3
#define HTTP_OK 4

#define MAX_HTTP_HEADERS 100

typedef struct {
  int type;
  int end_header;
  double version;
  char filename[PATH_MAX];
  char *keys[MAX_HTTP_HEADERS];
  char *values[MAX_HTTP_HEADERS];
  int num_headers;
} http_request;

void http_parse_request(char *headers, http_request *request);
void http_parse_headers(char *headers, http_request *request);

int http_find_header_end(io_buffer *iobuf, int end_header);

char *guess_mime_type(char *filename);

void decode_url(char *encoded);
void fix_slashes(char *original);

#endif //__HTTP_H__
